import rhinoscriptsyntax as rs
import scriptcontext

def InterpolateSingleColor(startColor,endColor,steps):
    return([int(startColor+(i*(endColor-startColor)/(steps-1))) for i in range(steps)])

def InterpolateColorRange():
    
    #check for previous settings
    if scriptcontext.sticky.has_key("StartChoice"):
        sChoice = scriptcontext.sticky["StartChoice"]
    else:
        sChoice=(0,0,0)
        
    if scriptcontext.sticky.has_key("EndChoice"):
        eChoice = scriptcontext.sticky["EndChoice"]
    else:
        eChoice=(255,255,255)
    
    #user input
    objs=rs.GetObjects("Select objects for color interpolation",preselect=True)
    if not objs: return
    
    rs.Prompt("Pick start color")
    sColor=rs.GetColor(sChoice)
    if not sColor: return
    
    rs.Prompt("Pick end color")
    eColor=rs.GetColor(eChoice)
    if not eColor: return

    #progression
    r=InterpolateSingleColor(sColor[0],eColor[0],len(objs))
    g=InterpolateSingleColor(sColor[1],eColor[1],len(objs))
    b=InterpolateSingleColor(sColor[2],eColor[2],len(objs))
    pass

    rs.EnableRedraw(False)
    for i in range(len(objs)):
        rs.ObjectColor(objs[i],(r[i],g[i],b[i]))
        
    #set previous values
    scriptcontext.sticky["StartChoice"]=sColor
    scriptcontext.sticky["EndChoice"]=eColor
    
InterpolateColorRange()